<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="企业id" prop="enterpriseId">
        <el-input v-model="formData.enterpriseId" placeholder="请输入企业id" />
      </el-form-item>
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="帐号状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="最后登录IP" prop="loginIp">
        <el-input v-model="formData.loginIp" placeholder="请输入最后登录IP" />
      </el-form-item>
      <el-form-item label="最后登录时间" prop="loginDate">
        <el-date-picker
          v-model="formData.loginDate"
          type="date"
          value-format="x"
          placeholder="选择最后登录时间"
        />
      </el-form-item>
      <el-form-item label="用户类型" prop="userType">
        <el-select v-model="formData.userType" placeholder="请选择用户类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.USER_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { EnterpriseUserBindApi, EnterpriseUserBindVO } from '@/api/menduner/system/enterprise/userBind'

/** 门墩儿-企业登录用户 表单 */
defineOptions({ name: 'EnterpriseUserBindForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  enterpriseId: undefined,
  userId: undefined,
  status: undefined,
  loginIp: undefined,
  loginDate: undefined,
  userType: undefined
})
const formRules = reactive({
  enterpriseId: [{ required: true, message: '企业id不能为空', trigger: 'blur' }],
  userId: [{ required: true, message: '用户id不能为空', trigger: 'blur' }],
  status: [{ required: true, message: '帐号状态（0正常 1停用 2 等待审核 3不通过）不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EnterpriseUserBindApi.getEnterpriseUserBind(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EnterpriseUserBindVO
    if (formType.value === 'create') {
      await EnterpriseUserBindApi.createEnterpriseUserBind(data)
      message.success(t('common.createSuccess'))
    } else {
      await EnterpriseUserBindApi.updateEnterpriseUserBind(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    enterpriseId: undefined,
    userId: undefined,
    status: undefined,
    loginIp: undefined,
    loginDate: undefined,
    userType: undefined
  }
  formRef.value?.resetFields()
}
</script>